(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common/http'), require('apollo-link'), require('apollo-link-batch'), require('graphql/language/printer'), require('apollo-angular-link-http-common'), require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('apollo-angular-link-http-batch', ['exports', '@angular/common/http', 'apollo-link', 'apollo-link-batch', 'graphql/language/printer', 'apollo-angular-link-http-common', '@angular/core'], factory) :
    (factory((global['apollo-angular-link-http-batch'] = {}),global.ng.common.http,global.apolloLink.core,global.apolloLink.batch,global.printer,global.ng.apolloLink.httpCommon,global.ng.core));
}(this, (function (exports,http,apolloLink,apolloLinkBatch,printer,apolloAngularLinkHttpCommon,core) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var defaults = {
        batchInterval: 10,
        batchMax: 10,
        uri: 'graphql',
        method: 'POST',
    };
    var HttpBatchLinkHandler = /** @class */ (function (_super) {
        __extends(HttpBatchLinkHandler, _super);
        function HttpBatchLinkHandler(httpClient, options) {
            var _this = _super.call(this) || this;
            _this.httpClient = httpClient;
            _this.options = options;
            _this.batchInterval = options.batchInterval || defaults.batchInterval;
            _this.batchMax = options.batchMax || defaults.batchMax;
            /** @type {?} */
            var batchHandler = ( /**
             * @param {?} operations
             * @return {?}
             */function (operations) {
                return new apolloLink.Observable(( /**
                 * @param {?} observer
                 * @return {?}
                 */function (observer) {
                    /** @type {?} */
                    var body = _this.createBody(operations);
                    /** @type {?} */
                    var headers = _this.createHeaders(operations);
                    var _a = _this.createOptions(operations), method = _a.method, uri = _a.uri, withCredentials = _a.withCredentials;
                    if (typeof uri === 'function') {
                        throw new Error("Option 'uri' is a function, should be a string");
                    }
                    /** @type {?} */
                    var req = {
                        method: method,
                        url: uri,
                        body: body,
                        options: {
                            withCredentials: withCredentials,
                            headers: headers,
                        },
                    };
                    /** @type {?} */
                    var sub = apolloAngularLinkHttpCommon.fetch(req, _this.httpClient).subscribe({
                        next: ( /**
                         * @param {?} result
                         * @return {?}
                         */function (result) { return observer.next(result.body); }),
                        error: ( /**
                         * @param {?} err
                         * @return {?}
                         */function (err) { return observer.error(err); }),
                        complete: ( /**
                         * @return {?}
                         */function () { return observer.complete(); }),
                    });
                    return ( /**
                     * @return {?}
                     */function () {
                        if (!sub.closed) {
                            sub.unsubscribe();
                        }
                    });
                }));
            });
            /** @type {?} */
            var batchKey = options.batchKey ||
                (( /**
                 * @param {?} operation
                 * @return {?}
                 */function (operation) {
                    return _this.createBatchKey(operation);
                }));
            _this.batcher = new apolloLinkBatch.BatchLink({
                batchInterval: _this.batchInterval,
                batchMax: _this.batchMax,
                batchKey: batchKey,
                batchHandler: batchHandler,
            });
            return _this;
        }
        /**
         * @private
         * @param {?} operations
         * @return {?}
         */
        HttpBatchLinkHandler.prototype.createOptions = /**
         * @private
         * @param {?} operations
         * @return {?}
         */
            function (operations) {
                /** @type {?} */
                var context = operations[0].getContext();
                return {
                    method: apolloAngularLinkHttpCommon.prioritize(context.method, this.options.method, defaults.method),
                    uri: apolloAngularLinkHttpCommon.prioritize(context.uri, this.options.uri, defaults.uri),
                    withCredentials: apolloAngularLinkHttpCommon.prioritize(context.withCredentials, this.options.withCredentials),
                };
            };
        /**
         * @private
         * @param {?} operations
         * @return {?}
         */
        HttpBatchLinkHandler.prototype.createBody = /**
         * @private
         * @param {?} operations
         * @return {?}
         */
            function (operations) {
                var _this = this;
                return operations.map(( /**
                 * @param {?} operation
                 * @return {?}
                 */function (operation) {
                    /** @type {?} */
                    var includeExtensions = apolloAngularLinkHttpCommon.prioritize(operation.getContext().includeExtensions, _this.options.includeExtensions, false);
                    /** @type {?} */
                    var includeQuery = apolloAngularLinkHttpCommon.prioritize(operation.getContext().includeQuery, _this.options.includeQuery, true);
                    /** @type {?} */
                    var body = {
                        operationName: operation.operationName,
                        variables: operation.variables,
                    };
                    if (includeExtensions) {
                        body.extensions = operation.extensions;
                    }
                    if (includeQuery) {
                        body.query = printer.print(operation.query);
                    }
                    return body;
                }));
            };
        /**
         * @private
         * @param {?} operations
         * @return {?}
         */
        HttpBatchLinkHandler.prototype.createHeaders = /**
         * @private
         * @param {?} operations
         * @return {?}
         */
            function (operations) {
                return operations.reduce(( /**
                 * @param {?} headers
                 * @param {?} operation
                 * @return {?}
                 */function (headers, operation) {
                    return apolloAngularLinkHttpCommon.mergeHeaders(headers, operation.getContext().headers);
                }), this.options.headers);
            };
        /**
         * @private
         * @param {?} operation
         * @return {?}
         */
        HttpBatchLinkHandler.prototype.createBatchKey = /**
         * @private
         * @param {?} operation
         * @return {?}
         */
            function (operation) {
                /** @type {?} */
                var context = operation.getContext();
                if (context.skipBatching) {
                    return Math.random()
                        .toString(36)
                        .substr(2, 9);
                }
                /** @type {?} */
                var headers = context.headers &&
                    context.headers.keys().map(( /**
                     * @param {?} k
                     * @return {?}
                     */function (k) { return context.headers.get(k); }));
                /** @type {?} */
                var opts = JSON.stringify({
                    includeQuery: context.includeQuery,
                    includeExtensions: context.includeExtensions,
                    headers: headers,
                });
                return apolloAngularLinkHttpCommon.prioritize(context.uri, this.options.uri) + opts;
            };
        /**
         * @param {?} op
         * @return {?}
         */
        HttpBatchLinkHandler.prototype.request = /**
         * @param {?} op
         * @return {?}
         */
            function (op) {
                return this.batcher.request(op);
            };
        return HttpBatchLinkHandler;
    }(apolloLink.ApolloLink));
    var HttpBatchLink = /** @class */ (function () {
        function HttpBatchLink(httpClient) {
            this.httpClient = httpClient;
        }
        /**
         * @param {?} options
         * @return {?}
         */
        HttpBatchLink.prototype.create = /**
         * @param {?} options
         * @return {?}
         */
            function (options) {
                return new HttpBatchLinkHandler(this.httpClient, options);
            };
        HttpBatchLink.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        HttpBatchLink.ctorParameters = function () {
            return [
                { type: http.HttpClient }
            ];
        };
        return HttpBatchLink;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var PROVIDERS = [HttpBatchLink];
    var HttpBatchLinkModule = /** @class */ (function () {
        function HttpBatchLinkModule() {
        }
        HttpBatchLinkModule.decorators = [
            { type: core.NgModule, args: [{
                        providers: PROVIDERS,
                    },] }
        ];
        return HttpBatchLinkModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.HttpBatchLink = HttpBatchLink;
    exports.HttpBatchLinkHandler = HttpBatchLinkHandler;
    exports.HttpBatchLinkModule = HttpBatchLinkModule;
    exports.PROVIDERS = PROVIDERS;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ng.apolloLink.httpBatch.umd.js.map